#ifndef _SKADNS_H_
#define _SKADNS_H_

#include "gccattributes.h"
#include "uint16.h"
#include "stralloc.h"

#define SKADNS_IPCPATH "/var/run/skadnsd-socket"
#define SKADNS_MAXCONCURRENCY 1000 /* MUST be < 65535 */
#define SKADNSD_PROG "/package/web/skadns-0.25/command/skadnsd"

typedef struct skadnsinfo skadnsinfo, *skadnsinfo_ref ;
typedef uint16 skadns_send_t (skadnsinfo_ref, char const *, unsigned int) ;
typedef int skadns_recv_t (skadnsinfo_ref, uint16, stralloc *) ;
typedef skadns_recv_t *skadns_recv_t_ref ;
typedef int dnspacket_t (stralloc *, char const *, unsigned int) ;
typedef dnspacket_t *dnspacket_t_ref ;


extern skadnsinfo_ref skadns_start (void) ;
extern skadnsinfo_ref skadns_startf (void) ;
extern void skadns_end (skadnsinfo_ref) ;
extern int skadns_fd (skadnsinfo const *) gccattr_pure ;
extern uint16 skadns_send (skadnsinfo_ref, char const *, char const[2]) ;
extern uint16 skadns_send_tmp (skadnsinfo_ref, char const *, char const[2], stralloc *) ;
extern int skadns_readanswers (skadnsinfo_ref) ;
extern uint16 const *skadns_recvlist (skadnsinfo const *) gccattr_pure ;
extern skadns_recv_t skadns_recv ;
extern int skadns_type_recv (skadnsinfo_ref, uint16, stralloc *, dnspacket_t_ref) ;

extern skadns_send_t skadns_ip4_send ;
extern skadns_recv_t skadns_ip4_recv ;
extern int skadns_ip4_check (stralloc *, char const *, unsigned int) ;

extern skadns_send_t skadns_ptr_send ;
extern skadns_recv_t skadns_ptr_recv ;
extern uint16 skadns_name4_send (skadnsinfo_ref, char const *) ;
#define skadns_name4_recv skadns_ptr_recv

extern skadns_send_t skadns_txt_send ;
extern skadns_recv_t skadns_txt_recv ;

extern skadns_send_t skadns_mx_send ;
extern skadns_recv_t skadns_mx_recv ;


/* TODO */

extern skadns_send_t skadns_ns_send ;
extern skadns_recv_t skadns_ns_recv ;

extern skadns_send_t skadns_soa_send ;
extern skadns_recv_t skadns_soa_recv ;

extern skadns_send_t skadns_srv_send ;
extern skadns_recv_t skadns_srv_recv ;

#endif
